# Auto Charts

### Full Auto-Detection Reference

When you have not specified `@chart`, ChartSQL will automatically choose a chart type when the following columns of the specified data types exist in the result set.&#x20;

<table data-full-width="false"><thead><tr><th width="238">Default Chart Type</th><th>Non-numeric Columns</th><th>Date Columns</th><th>Datetime Columns</th><th>Numeric Columns</th><th>X-axis</th><th>Y-axis</th><th>Additional Axis/Property</th><th>Rule</th></tr></thead><tbody><tr><td>Column</td><td>1</td><td>0</td><td>0</td><td>1</td><td>Non-numeric</td><td>Numeric</td><td></td><td>1</td></tr><tr><td>Grouped Column</td><td>1</td><td>0</td><td>0</td><td>2 or more</td><td>Non-numeric</td><td>Numeric</td><td></td><td>2</td></tr><tr><td>Date-based Line</td><td>0</td><td>1</td><td>0</td><td>1 or more</td><td>Date</td><td>Numeric</td><td></td><td>3</td></tr><tr><td>Datetime based line</td><td>0</td><td>0</td><td>1</td><td>1 or more</td><td>Datetime</td><td>Numeric</td><td></td><td>4</td></tr><tr><td>Stacked-Grouped Column</td><td>2 or more</td><td>0</td><td>0</td><td>2</td><td>Non-numeric 1</td><td>Numeric</td><td>Non-numeric 2 (subcategories)</td><td>5</td></tr><tr><td>Scatter</td><td>0</td><td>0</td><td>0</td><td>2</td><td>Numeric 1</td><td>Numeric 2</td><td></td><td>6</td></tr><tr><td>Bubble (scatter with size)</td><td>0</td><td>0</td><td>0</td><td>3</td><td>Numeric 1</td><td>Numeric 2</td><td>Numeric 3 (bubble size)</td><td>7</td></tr><tr><td>Heatmap</td><td>2</td><td>0</td><td>0</td><td>1</td><td>Non-numeric 1</td><td>Non-numeric 2</td><td>Numeric (color intensity)</td><td>8</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.chartsql.com/reference/auto-charts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
